<?php

use Drupal\slider_pro\SliderProOptionset;

/**
 * Prepares variables for slider pro view templates.
 *
 * Default template: slider-pro-views-style.html.twig.
 */
function template_preprocess_slider_pro_views_style(array &$variables) {
  if (empty($variables['view'])) {
    return;
  }

  if (!$optionset = new SliderProOptionset($variables['options'])) {
    // Settings have not been set yet.
    return;
  }

  // Build render array.
  $id = 'slider-pro-' . uniqid();
  $content = array(
    '#theme' => 'slider_pro',
    '#rows' => $variables['rows'],
    '#uses_thumbnails' => !empty($variables['options']['thumbnails']['position']),
    '#id' => $id,
  );

  $attached = [];

  // JavaScript settings
  $js_settings = array(
    'instances' => array(
      $id => $optionset->toArray(),
    ),
  );
  // Add JS.
  $attached['library'][] = 'slider_pro/slider.pro.load';
  $content['#attached'] = [
    'library' => [
      'slider_pro/slider.pro.load'
    ],
    'drupalSettings' => [
      'sliderPro' => $js_settings,
    ],
  ];

  // Add the slide items to the variables.
  $variables['content'] = $content;
}
